#include <ri.h>
#include <stdio.h>

#include <ri.h>
#include <stdio.h>

#define L -.5       /* For x: left side     */
#define R  .5       /* For x: right side    */
#define D -.5       /* For y: down side     */
#define U  .5       /* For y: upper side    */
#define F  .5       /* For z: far side      */
#define N -.5       /* For z: near side     */

/* UnitCube(): define a cube in the graphics environment */
UnitCube()
{
    static RtPoint Cube[6][4] = {
        { {L,D,F},  {L,D,N},  {R,D,N},  {R,D,F} },   /* Bottom face  */
        { {L,D,F},  {L,U,F},  {L,U,N},  {L,D,N} },   /* Left face    */
        { {R,U,N},  {L,U,N},  {L,U,F},  {R,U,F} },   /* Top  face    */
        { {R,U,N},  {R,U,F},  {R,D,F},  {R,D,N} },   /* Right face   */
        { {R,D,F},  {R,U,F},  {L,U,F},  {L,D,F} },   /* Far face     */
        { {L,U,N},  {R,U,N},  {R,D,N},  {L,D,N} }    /* Near face    */
    };
    int i;
    for( i = 0; i < 6; i++)  /* Declare the cube  */
        RiPolygon( (RtInt) 4, RI_P, (RtPointer) Cube[i], RI_NULL);    
}

void
ColorCube(n, s)
int n;
float s;
{
    int x, y, z;
    RtColor color;

    if( n<=0 )
        return;

    RiAttributeBegin();

	    RiTranslate(-.5, -.5, -.5 );
        RiScale(1.0/n, 1.0/n, 1.0/n);

        for(x = 0; x < n; x++)
            for(y = 0; y < n; y++)
                for(z = 0; z < n; z++) {
                    color[0] = ((float) x+1) / ((float) n);
                    color[1] = ((float) y+1) / ((float) n);
                    color[2] = ((float) z+1) / ((float) n);
                    RiColor(color);
                    RiTransformBegin();
                        RiTranslate (x+.5, y+.5, z+.5);
                        RiScale(s, s, s);
                        UnitCube();
                    RiTransformEnd ();
                }

    RiAttributeEnd();
}

main()
{
    RiBegin("rgl");   /* Start the renderer */
	
        RiLightSource( "distantlight", RI_NULL); 
        RiProjection( "perspective", RI_NULL);

        RiTranslate(0.0, 0.0, 2.0);
		RiRotate(40.0, 0.0, 1.0, 0.0);
		RiRotate(40.0, 1.0, 0.0, 0.0);
                    
        RiWorldBegin();
            RiSurface("matte", RI_NULL);
			ColorCube(5, 0.7);
        RiWorldEnd();
    
    RiEnd();                /* Clean up after the renderer */

    return 0;
}

